﻿using System;
using System.Web.Routing;
using Ninject;
using System.Web.Mvc;
using FitnessDiary.Domain.Abstract;
using FitnessDiary.Domain.Concrete;
using FitnessDiary.WebUI.Account;

namespace FitnessDiary.WebUI.Infrastructure
{
	public class NinjectControllerFactory : DefaultControllerFactory
	{
		private IKernel ninjectKernel;

		public NinjectControllerFactory()
		{
			ninjectKernel = new StandardKernel();
			AddBindings();
		}

		protected override IController GetControllerInstance(RequestContext requestContext, Type controllerType)
		{
			return controllerType == null ? null : (IController)ninjectKernel.Get(controllerType);
		}

		private void AddBindings()
		{
			ninjectKernel.Bind<IFitnessDiaryRepository>().To<FitnessDiaryRepository>();
			ninjectKernel.Bind<IUserProvider>().To<UserProvider>();
		}
	}
}